/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-08-01 03:55
**/

#include<bits/stdc++.h>
using namespace std;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef long double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;

const int MAXN = 2e5 + 5;
ll N;
ll m;
string l, r;

void solve(){
    // Code goes here ...
    string db;
    cin >> db;
    int len = size(db);

    cin >> m;
    cin >> l >> r;

    int pos = 0;
    R(i, m){
        set<int> poss;
        F(j, l[i], r[i] + 1)
            poss.emplace(j);

        while(not poss.empty() and pos < len)
            poss.erase(db[pos++]);

        if(not poss.empty() and pos >= len){
            cout << "YES" << endl;
            return;
        }
    }
    cout << "NO" << endl;
}

int main(){
    cout << fixed << setprecision(8);
    int T;
    cin >> T;
    while(T--)
        solve();
}
        
